package se.chalmers.cs.gf.tramdemo;

import se.gu.ling.trindikit.oaa.common.*;

import se.chalmers.cs.gf.util.FileUtil;

import java.io.IOException;
import java.util.Properties;

public class MapAgent extends OAAAgent {
    
        /** The name of this agent. */
        static final String name = "MapAgent";

        /** The only state of this agent. */
        static final int RUNNING = 0; 

        public MapAgent(TramMap map, String[] args) {
                super(RUNNING,1);

                addSolver(RUNNING, new MapDrawSolver(map));
                addSolver(RUNNING, new MapClickSolver(map));
                
                if (!register(name,args))
                        System.err.println(name + ": register() failed");
        }
    
        public static void main(String[] args) throws IOException {
                if (args.length < 1 || !args[0].endsWith(".properties")) {
                        System.err.println("Usage: java se.chalmers.cs.gf.tramdemo.MapAgent <properties file> [-oaa_connect tcp('$HOST',$FAC_PORT)]");
                        System.exit(1);
                }

                Properties cityProps = FileUtil.readPropertiesResource(args[0]);

                double clickThreshold = Double.parseDouble(cityProps.getProperty("clickThreshold"));
                String backgroundImageResource = cityProps.getProperty("backgroundImage");

                String graphResource = cityProps.getProperty("graph");
                TransportNetwork tn = DotToGraph.fromDotResource(graphResource);
                TramMap map = TramMap.showMap(clickThreshold, tn, backgroundImageResource);

                new MapAgent(map, args);
        }

}
